package org.classpath.icedtea.pulseaudio;

import javax.sound.sampled.BooleanControl;
import javax.sound.sampled.FloatControl;
import javax.sound.sampled.Line;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.Port;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class PulseAudioSourcePortTest {

	Mixer mixer;

	@Before
	public void setUp() throws Exception {
		mixer = PulseAudioMixer.getInstance();
		mixer.open();

	}

	@Test
	public void testClose() throws LineUnavailableException {
		Line.Info[] lineInfos = mixer.getSourceLineInfo();
		for (Line.Info info : lineInfos) {
			if (info.getLineClass() == Port.class) {
				System.out.println(info.toString());
				Port port = (Port) mixer.getLine(info);
				port.close();
			}
		}
	}

	@Test
	public void testControls() throws LineUnavailableException {
		Line.Info[] lineInfos = mixer.getSourceLineInfo();
		for (Line.Info info : lineInfos) {
			if (info.getLineClass() == Port.class) {
				System.out.println(info.toString());
				Port port = (Port) mixer.getLine(info);
				FloatControl volumeControl = (FloatControl) port
						.getControl(FloatControl.Type.VOLUME);
				volumeControl.setValue(60000);
				BooleanControl muteControl = (BooleanControl) port
						.getControl(BooleanControl.Type.MUTE);
				muteControl.setValue(true);
				muteControl.setValue(false);
			}
		}
	}

	@After
	public void tearDown() {
		mixer.close();

	}

}
